 /**
  * changeDomain.cpp
  */
 
 #include <stdio.h>
 #include <stdlib.h>
 #include <windows.h>
 #include <lm.h>
 #include <lmjoin.h>
 
 #define BUFSIZE 256
 
 #define ARG_DOMAIN  1 // ̓hC or [NO[v
 #define ARG_ACCOUNT 2 // ̓[U(hCύX̂ݕKv)
 #define ARG_PASSWD  3 // O̓pX[h(hCύX̂ݕKv)
 
 #define JOIN_WG     NETSETUP_JOIN_UNSECURE
 #define JOIN_DOMAIN NETSETUP_JOIN_DOMAIN+NETSETUP_ACCT_CREATE+NETSETUP_DOMAIN_JOIN_IF_JOINED
 
 int main( int argc , char** argv ){
 	
 	/* ̗ */
 	for( int cnt = 1 ; cnt < argc ; cnt++ ){
 		printf( "arg%d : %s\n" , cnt , argv[cnt] );
 	}
 
 	/* [NO[vEhCύX */
 	NET_API_STATUS ret; // NetJoinDomain̕Ԓli[
 	
 	switch( argc ){
 	case 2:
 		/* [NO[vύXꍇ */
 		WCHAR workGroup[BUFSIZE];
 		
 		MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,argv[ARG_DOMAIN],-1,workGroup,sizeof(workGroup));
 
 		ret = NetJoinDomain( NULL , workGroup , NULL , NULL , NULL , JOIN_WG );
 		break;
 		
 	case 4:
 		/* hCύXꍇ */
 		WCHAR domain[BUFSIZE];
 		WCHAR account[BUFSIZE];
 		WCHAR passwd[BUFSIZE];
 		
 		MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,argv[ARG_DOMAIN] ,-1,domain ,sizeof(domain));
 		MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,argv[ARG_ACCOUNT],-1,account,sizeof(account));
 		MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,argv[ARG_PASSWD] ,-1,passwd ,sizeof(passwd));
 		
 		ret = NetJoinDomain( NULL , domain , NULL , account , passwd , JOIN_DOMAIN );
 		break;
 		
 	default:
 		/* ̐Ƃ */
 		printf( "Error : invalid Argument\n" );
 		return -1;
 	}
 	
 	/* G[ */
 	switch( ret ){
 	case ERROR_INVALID_PARAMETER:
 		printf( "Error : Invalid Parameters.\n" );
 		return -1;
 	case ERROR_NO_SUCH_DOMAIN:
 		printf( "Error : No such domain.\n" );
 		return -1;
 	case NERR_SetupAlreadyJoined:
 		printf( "Error : This computer is already joined to the domain.\n" );
 		return -1;
 	case NERR_InvalidWorkgroupName:
 		printf( "Error : Workgroup Name is invalid.\n" );
 		return -1;
 	}
 	
 	/* I */
 	printf( "succeeded\n" );
 	
 	return 0;
 }